<?php

/*

+-----------------------------------------------------------------------+

Plugin Name: HDavecPrefixe

Version: 2.0-beta2

Description: Permet le nommage des photos en haute dfinition avec un prefixe au choix

Plugin URI: http://fr.piwigo.org/ext/extension_view.php?eid=274

Author:Didou

Author URI:www.mimamou.fr

+-----------------------------------------------------------------------+

| This program is free software; you can redistribute it and/or modify  |

| it under the terms of the GNU General Public License as published by  |

| the Free Software Foundation                                          |

|                                                                       |

| This program is distributed in the hope that it will be useful, but   |

| WITHOUT ANY WARRANTY; without even the implied warranty of            |

| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |

| General Public License for more details.                              |

|                                                                       |

| You should have received a copy of the GNU General Public License     |

| along with this program; if not, write to the Free Software           |

| Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |

| USA.                                                                  |

+-----------------------------------------------------------------------+

*/

class HDPrefixe

{

    

	var $my_config;

    function load_config()

    {
       $query = '
			SELECT value 
			FROM '.CONFIG_TABLE.'
			WHERE param = \'hdavecprefixe_prefixe\'
		;';

		$result = pwg_query($query);

		if($result) {
			while ($row = mysql_fetch_array($result))
			{
				$this->my_config['Prefixe'] = $row['value'];
			}
		}
				
        if (!isset($this->my_config)
            or empty($this->my_config['Prefixe']) )
        {
            $this->my_config['Prefixe'] = 'HD-';
            $this->save_config();
        }
		
		$query = '
			SELECT value 
			FROM '.CONFIG_TABLE.'
			WHERE param = \'hdavecprefixe_synchro\'
		;';

		$result = pwg_query($query);

		if($result) {
			while ($row = mysql_fetch_array($result))
			{
				$this->my_config['Synchro'] = $row['value'];
			}
		}
				
        if (!isset($this->my_config)
            or empty($this->my_config['Synchro']) )
        {
            $this->my_config['Synchro'] = 'false';
            $this->save_config();
        }
		
		$query = '
			SELECT value 
			FROM '.CONFIG_TABLE.'
			WHERE param = \'hdavecprefixe_erreurs\'
		;';

		$result = pwg_query($query);

		if($result) {
			while ($row = mysql_fetch_array($result))
			{
				$this->my_config['Erreurs'] = $row['value'];
			}
		}
				
        if (!isset($this->my_config)
            or empty($this->my_config['Erreurs']) )
        {
            $this->my_config['Erreurs'] = 'false';
            $this->save_erreurs();
        }
    }

    function save_prefixe(){
		$result=false;
		$query = '
			REPLACE INTO '.CONFIG_TABLE.' 
			VALUES(
			\'hdavecprefixe_prefixe\',
			\''.$this->my_config['Prefixe'].'\',
			\'Prefixe pour HDavecPrefixe\')
		;';
		
		$result = pwg_query($query);
    
		if($result) {
			return true;
		} 
		else {
			return false;
		}

    }

    function save_synchro(){
		$query = '
			REPLACE INTO '.CONFIG_TABLE.' 
			VALUES(
			\'hdavecprefixe_synchro\',
			\''.$this->my_config['Synchro'].'\',
			\'Synchro automatique pour HDavecPrefixe\')
		;';
		
		$result = pwg_query($query);

		if($result) {
			return true;
		} 
		else {
			return false;
		}
	}
	
	function save_erreurs(){
		$query = '
			REPLACE INTO '.CONFIG_TABLE.' 
			VALUES(
			\'hdavecprefixe_erreurs\',
			\''.$this->my_config['Erreurs'].'\',
			\'Annulation modifications avant Synchronisation\')
		;';
		
		$result = pwg_query($query);

		if($result) {
			return true;
		} 
		else {
			return false;
		}
	}

	/*function modif_url($url)

	{

		$tab_explode=explode("/",$url);

		$nomfichier=array_pop($tab_explode);

		$newurl=implode("/",$tab_explode);

		$newurl=$newurl."/".$this->my_config['Prefixe'].$nomfichier;

		return $newurl;

	}*/

	function modif_location($location, $element_info)

	{

		global $prefixeTable;

		$newlocation = '';

		$query = '
		SELECT *
		FROM `'.$prefixeTable.'hdavecprefixe`
		WHERE `id_image` = '.$element_info['id'].'
		;';

		$result = pwg_query($query);

		if($result){
			while ($row = mysql_fetch_array($result))
			{
				$pi = pathinfo($element_info['path']);
				if ($row['has_high'] == 'image')
				{
					$newlocation=$pi['dirname'].'/pwg_high/'.$this->my_config['Prefixe'].$pi['basename'];
				}
				else if ($row['has_high'] == 'zip')
				{
					$newlocation=$pi['dirname'].'/pwg_high/'.$this->my_config['Prefixe'].$pi['filename'].'.zip';
				}
			}
		}
		else{
			$newlocation=$location;
		}
		return $newlocation;

	}

	function avant_synchro(){
		$fields =
			array(
			'primary' => array('id'),
			'update'  => array('has_high', 'high_filesize')
			);
		$datas = array();
		
		$query = '
		SELECT id, path
		FROM '.IMAGES_TABLE.'
		;';
		$result = pwg_query($query);
		
		$nb_images=0;
		
		while ($row = mysql_fetch_array($result)){
			$data['id']=$row['id'];
			$data['has_high'] = NULL;		  
			$data['high_filesize'] = NULL;
			array_push($datas, $data);
		}
		mass_updates(IMAGES_TABLE, $fields, $datas);
	}
	

	function synchro_has_high(){
	
		global $prefixeTable;
		
		$query = '
			 TRUNCATE TABLE `'.$prefixeTable.'hdavecprefixe`
		;';
		pwg_query($query);
		
		$this->load_config();
		
		$hd_dbfields = array('id_image','has_high','high_filesize');
		$hd_datas = array();
		
		$fields =
			array(
			'primary' => array('id'),
			'update'  => array('has_high', 'high_filesize')
			);
		$datas = array();
		
		$query = '
		SELECT id, path
		FROM '.IMAGES_TABLE.'
		;';
		$result = pwg_query($query);
		
		$nb_images=0;
		
		while ($row = mysql_fetch_array($result))
		{
		    $pi = pathinfo($row['path']);
			$high_file_prefixe = $pi['dirname'].'/pwg_high/'.$this->my_config['Prefixe'].$pi['basename'];
			$high_file_prefixe_zip = $pi['dirname'].'/pwg_high/'.$this->my_config['Prefixe'].$pi['filename'].'.zip';
			if (is_file($high_file_prefixe)){	
				$hd_data['id_image']=$row['id'];
				$hd_data['has_high'] = 'image';		  
				$hd_data['high_filesize'] = floor(filesize($high_file_prefixe)/1024);
				array_push($hd_datas, $hd_data);
				
				$data['id']=$row['id'];
				$data['has_high'] = true;		  
				$data['high_filesize'] = floor(filesize($high_file_prefixe)/1024);
				array_push($datas, $data);
				
				$nb_images++;
			}
			
			else if (is_file($high_file_prefixe_zip)){	
			
				$hd_data['id_image']=$row['id'];
				$hd_data['has_high'] = 'zip';		  
				$hd_data['high_filesize'] = floor(filesize($high_file_prefixe_zip)/1024);
				array_push($hd_datas, $hd_data);
				
				$data['id']=$row['id'];
				$data['has_high'] = true;		  
				$data['high_filesize'] = floor(filesize($high_file_prefixe_zip)/1024);
				array_push($datas, $data);
				
				$nb_images++;
			}
		}
		
		$result=mass_inserts('`'.$prefixeTable.'hdavecprefixe`',$hd_dbfields, $hd_datas);
		
		mass_updates(IMAGES_TABLE, $fields, $datas);
		
		return $result.'<br />'.$nb_images.' images haute d&eacute;finition avec pr&eacute;fixe mise &agrave; jour';
		
	}

}

?>